-- Copyright 2023 by Todd Hundersmarck (ThundR)
-- All Rights Reserved

THData = {}
local THData_mt = Class(THData)
function THData.new(parent, customMt)
customMt = Utils.getNoNil(customMt, THData_mt)
if THUtils.argIsValid(type(parent) == "table", "parent", parent)
and THUtils.argIsValid(type(customMt) == "table", "customMt", customMt)
then
local newEnv = setmetatable({}, customMt)
if newEnv ~= nil then
newEnv.parentTable = parent
newEnv.defaultValues = {}
newEnv.isTableInitialized  = false
newEnv.hasEnvironmentHooks = false
end
return newEnv
end
end
function THData:getParent()
return self.parentTable
end
function THData:getParentValue(key)
local parent = self:getParent()
return parent[key]
end
function THData:updateDefaultValues(reset)
local parent = self:getParent()
if reset then
THUtils.clearTable(self.defaultValues)
end
for k, v in pairs(parent) do
self.defaultValues[k] = v
end
end
function THData:getDefaultValue(key)
return self.defaultValues[key]
end
function THData:restoreDefaultValue(key)
local parent = self:getParent()
local parentValue = rawget(parent, key)
local defaultValue = self.defaultValues[key]
if parentValue ~= defaultValue then
rawset(parent, key, defaultValue)
end
end
function THData:restoreDefaultValues()
local parent = self:getParent()
for k, v in pairs(self.defaultValues) do
rawset(parent, k, v)
end
end