-- Copyright 2023 by Todd Hundersmarck (ThundR)
-- All Rights Reserved

VHXClearFillTypeUsageEvent = {}
local VHXClearFillTypeUsageEvent_mt = Class(VHXClearFillTypeUsageEvent, Event)
InitEventClass(VHXClearFillTypeUsageEvent, "VHXClearFillTypeUsageEvent")
function VHXClearFillTypeUsageEvent.emptyNew()
return Event.new(VHXClearFillTypeUsageEvent_mt)
end
function VHXClearFillTypeUsageEvent.new(vehicle)
if THUtils.argIsValid(THUtils.getIsType(vehicle, Vehicle), "vehicle", vehicle, true) then
local self = VHXClearFillTypeUsageEvent.emptyNew()
self.vehicle = vehicle
return self
end
end
function VHXClearFillTypeUsageEvent:readStream(streamId, connection)
self.vehicle = NetworkUtil.readNodeObject(streamId)
self:run(connection)
end
function VHXClearFillTypeUsageEvent:writeStream(streamId, connection)
NetworkUtil.writeNodeObject(streamId, self.vehicle)
end
function VHXClearFillTypeUsageEvent:run(connection)
if not connection:getIsServer() then
local vehicleData = g_thMain:getDataTable(self.vehicle)
if vehicleData ~= nil then
vehicleData:clearVHXUsage()
end
end
end
function VHXClearFillTypeUsageEvent.sendEvent(vehicle)
local function protectedFunc()
local newEvent = VHXClearFillTypeUsageEvent.new(vehicle)
if newEvent ~= nil then
if vehicle.isClient and not vehicle.isServer then
g_client:getServerConnection():sendEvent(newEvent)
end
end
end
g_thMain:call(protectedFunc)
end