-- Copyright 2023 by Todd Hundersmarck (ThundR)
-- All Rights Reserved

VHXClearWorkedAreaEvent = {}
local VHXClearWorkedAreaEvent_mt = Class(VHXClearWorkedAreaEvent, Event)
InitEventClass(VHXClearWorkedAreaEvent, "VHXClearWorkedAreaEvent")
function VHXClearWorkedAreaEvent.emptyNew()
return Event.new(VHXClearWorkedAreaEvent_mt)
end
function VHXClearWorkedAreaEvent.new(vehicle)
if THUtils.argIsValid(THUtils.getIsType(vehicle, Vehicle), "vehicle", vehicle, true) then
local self = VHXClearWorkedAreaEvent.emptyNew()
self.vehicle = vehicle
return self
end
end
function VHXClearWorkedAreaEvent:readStream(streamId, connection)
self.vehicle = NetworkUtil.readNodeObject(streamId)
self:run(connection)
end
function VHXClearWorkedAreaEvent:writeStream(streamId, connection)
NetworkUtil.writeNodeObject(streamId, self.vehicle)
end
function VHXClearWorkedAreaEvent:run(connection)
if not connection:getIsServer() then
local vehicleData = g_thMain:getDataTable(self.vehicle)
if vehicleData ~= nil then
vehicleData:clearVHXWorkedArea()
end
end
end
function VHXClearWorkedAreaEvent.sendEvent(vehicle)
local function protectedFunc()
local newEvent = VHXClearWorkedAreaEvent.new(vehicle)
if newEvent ~= nil then
if vehicle.isClient and not vehicle.isServer then
g_client:getServerConnection():sendEvent(newEvent)
end
end
end
g_thMain:call(protectedFunc)
end