-- Copyright 2023 by Todd Hundersmarck (ThundR)
-- All Rights Reserved

VHXVehicle = {}
function VHXVehicle:clearVHXUsage()
local vehicle = self:getParent()
if vehicle.isServer then
local function processVehicle(pVehicle)
local vhxUsageSpec = g_thMain:getSpecTable(pVehicle, "vhxFillTypeUsage")
if vhxUsageSpec ~= nil then
vhxUsageSpec:clearVHXUsage()
end
end
local rootVehicle = vehicle:getRootVehicle()
if rootVehicle == nil then
processVehicle(vehicle)
else
processVehicle(rootVehicle)
local childVehicles = rootVehicle:getChildVehicles()
if childVehicles ~= nil then
for _, childVehicle in pairs(childVehicles) do
if childVehicle ~= rootVehicle then
processVehicle(childVehicle)
end
end
end
end
else
VHXClearFillTypeUsageEvent.sendEvent(vehicle)
end
end
function VHXVehicle:getVHXUsageValues(fillType)
local vehicle = self:getParent()
local rootVehicle = vehicle:getRootVehicle()
local usageValue, yieldValue = nil, nil
local function processVehicle(pVehicle)
local vhxUsageSpec = g_thMain:getSpecTable(pVehicle, "vhxFillTypeUsage")
if vhxUsageSpec ~= nil then
local usageTable, yieldTable = vhxUsageSpec:getVHXUsageData(fillType)
if usageTable ~= nil then
if usageValue == nil then
usageValue = usageTable.average
else
usageValue = (usageValue + usageTable.average) / 2
end
end
if yieldTable ~= nil then
if yieldValue == nil then
yieldValue = yieldTable.average
else
yieldValue = (yieldValue + yieldTable.average) / 2
end
end
end
end
if rootVehicle == nil then
processVehicle(self)
else
processVehicle(rootVehicle)
local childVehicles = rootVehicle:getChildVehicles()
if childVehicles ~= nil then
for _, childVehicle in pairs(childVehicles) do
if childVehicle ~= rootVehicle then
processVehicle(childVehicle)
end
end
end
end
return usageValue, yieldValue
end
function VHXVehicle:clearVHXWorkedArea()
local vehicle = self:getParent()
local rootVehicle = vehicle:getRootVehicle()
if vehicle.isServer then
local function processVehicle(pVehicle)
local vhxWorkedAreaSpec = g_thMain:getSpecTable(pVehicle, "vhxWorkedArea")
if vhxWorkedAreaSpec ~= nil then
vhxWorkedAreaSpec:clearVHXWorkedArea()
end
end
if rootVehicle == nil then
processVehicle(self)
else
processVehicle(rootVehicle)
local childVehicles = rootVehicle:getChildVehicles()
if childVehicles ~= nil then
for _, childVehicle in pairs(childVehicles) do
if childVehicle ~= rootVehicle then
processVehicle(childVehicle)
end
end
end
end
else
VHXClearWorkedAreaEvent.sendEvent(vehicle)
end
end
function VHXVehicle:getVHXWorkedArea()
local vehicle = self:getParent()
local rootVehicle = vehicle:getRootVehicle()
local totalWorkedHectares = nil
local function processVehicle(pVehicle)
local vhxWorkedAreaSpec = g_thMain:getSpecTable(pVehicle, "vhxWorkedArea")
if vhxWorkedAreaSpec ~= nil then
local workedHectares = vhxWorkedAreaSpec:getVHXWorkedArea()
totalWorkedHectares = THUtils.getNoNil(totalWorkedHectares, 0)
totalWorkedHectares = totalWorkedHectares + workedHectares
end
end
if rootVehicle == nil then
processVehicle(self)
else
processVehicle(rootVehicle)
local childVehicles = rootVehicle:getChildVehicles()
if childVehicles ~= nil then
for _, childVehicle in pairs(childVehicles) do
if childVehicle ~= rootVehicle then
processVehicle(childVehicle)
end
end
end
end
return totalWorkedHectares
end
function VHXVehicle:hook_loadFinished(superFunc, ...)
local function prependFunc()
g_thMain:createDataTable(self, nil, false, VHXVehicle)
end
g_thMain:call(prependFunc)
return superFunc(self, ...)
end
local function runScript()
g_thMain:setProtectedHook("Vehicle", "loadFinished", VHXVehicle)
end
g_thMain:call(runScript)